   (SETQ *ALL-WINDOWS*)
   (DEFFLAVOR WINDOW
   ;    
      (
         TOP              ;    
         LEFT             ;     
         HEIGHT           ;   
         WIDTH            ;   
         (CURRENT-ROW 0)  ;   ()
         (CURRENT-COL 0)  ;   ()
         (EXPOSEDP  NIL)  ;   ( ?) ?
         (BORDER 1)       ;    
         (BORDER-COLOR 7) ;  
         (FOREGROUND 15)  ;    
         (BACKGROUND 0)   ;   
      )
      ()                  ;  
      :SETTABLE-INSTANCE-VARIABLES
      :GETTABLE-INSTANCE-VARIABLES
   )
   ; ---------------------------------
   (DEFMETHOD (WINDOW :AFTER :INIT) ()
   ;   ,     
   ;  
      (PUSH SELF *ALL-WINDOWS*)
   )
   ; ----------------------------
   (DEFMETHOD (WINDOW :EXPOSE) ()
   ;    :     -
   ;  ,      -
   ; ,    ;    -
   ;  
      ( (SEND SELF :EXPOSEDP)
        (MAKE-WINDOW (+ TOP BORDER)
                     (+ LEFT BORDER)
                     (- HEIGHT (* 2 BORDER))
                     (- WIDTH  (* 2 BORDER))
        )
        (SET-CURSOR CURRENT-ROW CURRENT-COL)
      )
     (SEND SELF :REFRESH)
   )
   ; -----------------------------
   (DEFMETHOD (WINDOW :REFRESH) ()
   ;  ""     
   ;      TRUE
      (BACKGROUND-COLOR BORDER-COLOR)
      (FOREGROUND-COLOR 0)
      (MAKE-WINDOW TOP LEFT HEIGHT WIDTH)
      (CLEAR-SCREEN)
      (BACKGROUND-COLOR BACKGROUND)
      (FOREGROUND-COLOR FOREGROUND)
      (MAKE-WINDOW (+ TOP BORDER)
                   (+ LEFT BORDER)
                   (- HEIGHT (* 2 BORDER))
                   (- WIDTH (* 2 BORDER))
      )
      (CLEAR-SCREEN)
      (SETQ CURRENT-ROW 0 CURRENT-COL 0)
      (SETQ EXPOSEDP 'T)
   )
   ; -------------------------------------------
   (DEFMETHOD (WINDOW :AFTER :REFRESH) (WINDOWS)
   ;  ,   ,    -
   ;        , 
   ;   
      (SETQ WINDOWS (REMOVE SELF *ALL-WINDOWS*))
      (LOOP
         ( (NULL WINDOWS) )
         ( ( (NO-OVERLAP TOP LEFT HEIGHT WIDTH (CAR WINDOWS))
               (POP WINDOWS)
           )
           (SEND (CAR WINDOWS) :SET-EXPOSEDP NIL)
           (POP WINDOWS)
         )
      )
   )
   ; -------------------------------------------------
   (DEFMETHOD (WINDOW :BEFORE :PRINT) (STR ROW COLUMN)
   ; ,   -   ,  
   ; 
      (SEND SELF :EXPOSE)
   )
   ; -------------------------------------------------
   (DEFMETHOD (WINDOW :BEFORE :PRINC) (STR ROW COLUMN)
   ; ,   -   ,  
   ; 
      (SEND SELF :EXPOSE)
   )
   ; -----------------------------------------
   (DEFMETHOD (WINDOW :PRINT) (STR ROW COLUMN)
   ;  STR   ROW  COLUMN 
      (IF  (AND (INTEGERP ROW) (INTEGERP COLUMN))
         (SET-CURSOR ROW COLUMN))
      (PRINT STR)
      (SETQ CURRENT-ROW (ROW) CURRENT-COL (COLUMN))
   )
   ; -----------------------------------------
   (DEFMETHOD (WINDOW :PRINC) (STR ROW COLUMN)
   ;  STR   ROW  COLUMN 
      (IF  (AND (INTEGERP ROW) (INTEGERP COLUMN))
         (SET-CURSOR ROW COLUMN))
      (PRINC STR)
      (SETQ CURRENT-ROW (ROW) CURRENT-COL (COLUMN))
   )
   ; -------------------------
   (DEFWHOPPER (WINDOW :PRINT)
                        (STR ROW COLUMN W1 W2 W3 W4 R C)
   ;         
   ;  ,     
   ; ,      
   ;  :PRINT
      (SETQ R (MAKE-WINDOW) W1 (POP R) W2 (POP R)
            W3 (POP R) W4 (POP R))
      (SETQ R (ROW) C (COLUMN))
      (IF (NO-OVERLAP W1 W2 W3 W4 SELF)
         (CONTINUE-WHOPPER STR ROW COLUMN))
      (MAKE-WINDOW W1 W2 W3 W4)
      (SET-CURSOR R C)
   )
   ; -------------------------
   (DEFWHOPPER (WINDOW :PRINC)
                         (STR ROW COLUMN W1 W2 W3 W4 R C)
   ;         
   ;  ,     
   ; ,      
   ;  :PRINC
      (SETQ R (MAKE-WINDOW) W1 (POP R) W2 (POP R)
            W3 (POP R) W4 (POP R))
      (SETQ R (ROW) C (COLUMN))
      (IF  (NO-OVERLAP W1 W2 W3 W4 SELF)
         (CONTINUE-WHOPPER STR ROW COLUMN))
      (MAKE-WINDOW W1 W2 W3 W4)
      (SET-CURSOR R C)
   )
   ; ---------------------------------------------------
   (DEFUN NO-OVERLAP (TOP1 LEFT1 HEIGHT1 WIDTH1 WINDOW2)
   ;      ,
   ;  TOP1 LEFT1 HEIGHT1 WIDTH1
      ( (LAMBDA (TOP2 LEFT2 HEIGHT2 WIDTH2
                 BOTTOM1 BOTTOM2 RIGHT1 RIGHT2)
           (SETQ BOTTOM1 (+ TOP1 HEIGHT1)
                 BOTTOM2 (+ TOP2 HEIGHT2)
                 RIGHT1  (+ LEFT1 WIDTH1)
                 RIGHT2  (+ LEFT2 WIDTH2))
           ( (OR (<= TOP1 TOP2 BOTTOM1)
                 (<= TOP1 BOTTOM2 BOTTOM1)
                 (<= TOP2 BOTTOM1 BOTTOM2))
             ( (OR (<= LEFT1 LEFT2 RIGHT1)
                   (<= LEFT1 RIGHT2 RIGHT1)
                   (<= LEFT2 RIGHT1 RIGHT2))
               NIL))
           'T
        )
        (SEND WINDOW2 :TOP)
        (SEND WINDOW2 :LEFT)
        (SEND WINDOW2 :HEIGHT)
        (SEND WINDOW2 :WIDTH)
      )
   )
   ;----------------------------------------
   ;    WINDOW
   (SETQ SMALL (MAKE-INSTANCE 'WINDOW
                              :TOP 2
                              :LEFT 10
                              :HEIGHT 8
                              :WIDTH 60))
   ; ---------------------------------------
   ;    WINDOW
   (SETQ TINY (MAKE-INSTANCE 'WINDOW
                              :TOP 3
                              :LEFT 30
                              :HEIGHT 8
                              :WIDTH 20
                              :BORDER 2))
   ; ---------------------------------------
   ;    WINDOW
   (SETQ MAIN (MAKE-INSTANCE 'WINDOW
                             :TOP 12
                             :LEFT 0
                             :HEIGHT 12
                             :WIDTH 80))
   ; ------------------------------------------
   (SEND MAIN :EXPOSE)     ;   MAIN
   (WRITE-LINE
     "  (SEND SMALL :PRINC 'HELLO 2 2)")
   (SEND SMALL :PRINC 'HELLO 2 2)
   (WRITE-LINE
     "  (SEND TINY :PRINC 'HELLO 2 2) ")
   (SEND TINY :PRINC 'HELLO 2 2)
   (SEND MAIN  :REFRESH)     ;   MAIN
   (SEND SMALL :REFRESH)     ;   SMALL
   (SEND TINY  :REFRESH)     ;   TINY
